Summary: AT Computing System Activity Report
Name: atsar_linux
Version: 1.5
Release: 1
Copyright: GPL
Group: Console/Monitoring
Source: ftp://ftp.atcomputing.nl/pub/tools/linux/atsar_linux-1.5.tar.gz
vendor: AT Computing
packager: Allan's Package-O-Matic Blenderfier
%description
The command atsar can be used to detect performance-bottlenecks
on LINUX-systems (similar to the command sar on other UNIX-platforms).
Atsar offers the possibility to show what is happening on the system
at this moment (by supplying an interval and the number of samples as
command-line arguments). However it also keeps track of the system-load
in the past by maintaining history-files from which information can be
extracted.
The current version of atsar gathers statistics about the utilization
of CPU's, disks, memory and swap, and network-interfaces (TCP/IP).

%prep
%setup

%build
make 

%install
install -m 0755 atsar/atsar      /usr/local/bin/atsar
install -m 0755 atsadc/atsadc    /usr/local/bin/atsadc
install -m 0755 scripts/atsa1    /usr/local/bin/atsa1
install -m 0755 scripts/atsaftp  /usr/local/bin/atsaftp
install -m 0755 scripts/atsahttp /usr/local/bin/atsahttp
install -m 0644 man/atsar.1      /usr/local/man/man1/atsar.1
install -m 0644 man/atsadc.1     /usr/local/man/man1/atsadc.1

%post
##########################################################################
# take care that atsadc is started regularly via cron
##########################################################################
ATSA1=/usr/local/bin/atsa1

# atsar version 1.4 called atsa1 from the crontab of root; be sure this is
# removed, since atsa1 will be called from /etc/crontab now
#
if [ "`crontab -u root -l 2>&1 | grep -c $ATSA1`" -gt 0 ]
then
	crontab -u root -l | grep -v $ATSA1 > /tmp/crontab_root
	crontab -u root -r
	crontab -u root /tmp/crontab_root
	rm /tmp/crontab_root
fi

# check if atsa1 is already called from /etc/crontab; if not, add lines
#
if [ "`cat /etc/crontab 2>&1 | grep -c $ATSA1`" -eq 0 ]
then
	echo '0     *    * * 0-6 root /usr/local/bin/atsa1' >> /etc/crontab
	echo '20,40 8-17 * * 1-5 root /usr/local/bin/atsa1' >> /etc/crontab
fi

##########################################################################
# take care that atsadc is started during reboot to reset counters
##########################################################################
RCLOCAL=/etc/rc.d/rc.local

if [ -f $RCLOCAL ]	# if a rc.local script is present, use it
then
	if [ "`grep -c '/usr/local/bin/atsadc' $RCLOCAL`" -eq 0 ]
	then
		echo '/usr/local/bin/atsadc /var/log/atsar/atsa`date +%d`'  \
					>> $RCLOCAL
		echo 'rm -f /var/log/atsar/ftpstat  2> /dev/null'           \
					>> $RCLOCAL
		echo 'rm -f /var/log/atsar/httpstat 2> /dev/null'           \
					>> $RCLOCAL
	fi
else			# else generate a rc2-script
	echo '/usr/local/bin/atsadc /var/log/atsar/atsa`date +%d`'          \
					 > /etc/rc.d/rc2.d/S88atsar_linux
	echo 'rm -f /var/log/atsar/ftpstat  2> /dev/null'                   \
					>> /etc/rc.d/rc2.d/S88atsar_linux
	echo 'rm -f /var/log/atsar/httpstat 2> /dev/null'                   \
					>> /etc/rc.d/rc2.d/S88atsar_linux

	chmod ug+x                        /etc/rc.d/rc2.d/S88atsar_linux
fi

##########################################################################
# adapt the script atsa1 when FTP and/or HTTP is used on this system
##########################################################################
if [ -f /var/log/xferlog ]
then
	cp /usr/local/bin/atsa1 /tmp/atsa1
	sed '/atsaftp/s/^# //'  /tmp/atsa1 > /usr/local/bin/atsa1
	rm   /tmp/atsa1
	echo 'Optional counting for  ftp-requests switched on ...'
fi

if [ -f /etc/httpd/httpd.conf -o 	\
     -f /etc/httpd/conf/httpd.conf -o   \
     -f /etc/httpd/apache/conf/httpd.conf ]
then
	cp /usr/local/bin/atsa1 /tmp/atsa1
	sed '/atsahttp/s/^# //'  /tmp/atsa1 > /usr/local/bin/atsa1
	rm   /tmp/atsa1
	echo 'Optional counting for http-requests switched on ...'
fi

##########################################################################
# take care that the directory for history-files is present, remove
# today's history-file (because of record-format incompatibility) and
# take a first snapshot to create a new history-file for today
##########################################################################
if [ ! -d /var/log/atsar ]
then
	mkdir /var/log/atsar
else
	rm    /var/log/atsar/atsa`date +%d` 2> /dev/null
	rm    /var/log/atsar/ftpstat        2> /dev/null
	rm    /var/log/atsar/httpstat       2> /dev/null
fi

/usr/local/bin/atsa1

##########################################################################

echo "All commands installed in directory /usr/local/bin!"

##########################################################################
%postun

ATSA1=/usr/local/bin/atsa1

cp /etc/crontab /tmp/crontab
grep -v $ATSA1  /tmp/crontab > /etc/crontab
rm              /tmp/crontab

RCLOCAL=/etc/rc.d/rc.local

if [ -f $RCLOCAL ]	# if rc.local script present, remove atsar-related cmds
then
	cp $RCLOCAL /tmp/rc.local
	grep -v '/var/log/atsar/' /tmp/rc.local > $RCLOCAL
	rm          /tmp/rc.local
else			# else remove rc2-script
	rm -f /etc/rc.d/rc2.d/S88atsar_linux 2> /dev/null
fi

%files
%doc README doc
/usr/local/bin/atsar
/usr/local/bin/atsadc
/usr/local/bin/atsa1
/usr/local/bin/atsaftp
/usr/local/bin/atsahttp
/usr/local/man/man1/atsar.1
/usr/local/man/man1/atsadc.1
